

% Short script to discretize a unit square and then write out the 
% graph info for Metis to chew upon. It is written to the file
% "metisgraph", which can then  be partitioned via
%   ./gpmetis metisgraph p

N = input('Number of mesh lines for the unknowns in each direction [default: 128]: ');
if isempty(N)
    N = 128;
end

n = N^2; 
disp(['Total number of unknowns is ', num2str(n)])

[rows, cols, vals, b] = setup(N);

% Check that the rows are in order 
% sortedrows = sort(rows);
% norm(rows-sortedrows)
% return

nnz = length(rows);
rowptrs =  zeros(1,n+1);
i = 1;
rowptrs(1) = 1;
for k = 2:n
    while (rows(i) == k-1)
        i = i+1;
    end
    rowptrs(k) = i;
end
rowptrs(n+1) = length(rows);

fh = fopen('metisgraph', 'wt');

% Metis wants only the number of edges, without self loops and 
% without counting A(i,j) and A(j,i) both.
nedges = (nnz - n)/2;
fprintf(fh, '%d  %d\n', n, nedges);
for k = 1:n
    for j = rowptrs(k):rowptrs(k+1)-1
        if cols(j) ~= k
            fprintf(fh, '%d   ', cols(j));
        end
    end
    fprintf(fh, '\n');
end
fclose(fh);
    
